.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include blank_dlg.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg == WM_INITDIALOG
 
            invoke lstrlen,addr szPassWord 
            invoke Rc4_setkey,addr szPassWord ,eax
    .elseif uMsg == WM_COMMAND
    
        .if wParam == IDC_ENCRYPT
        
            invoke lstrlen,addr szPassWord 
            invoke Rc4_setkey,addr szPassWord ,eax
            
            invoke SendDlgItemMessage,hWnd,IDE_INPUT, WM_GETTEXTLENGTH, 0, 0
               inc eax ; terminating zero
               mov ln, eax
               mov hInput, alloc$(eax)
            invoke SendDlgItemMessage, hWnd,IDE_INPUT, WM_GETTEXT,ln,hInput
            invoke lstrlen,hInput

invoke lstrlen, addr szPassWord
invoke Rc4_setkey, addr szPassWord, eax

            invoke Rc4_crypt,hInput,eax
            invoke SetDlgItemText,hWnd,IDE_OUTPUT,hInput
            
         .elseif wParam == IDC_DECRYPT 
         
            invoke lstrlen,addr szPassWord
            invoke Rc4_setkey,addr szPassWord ,eax

            invoke SendDlgItemMessage,hWnd,IDE_OUTPUT, WM_GETTEXTLENGTH, 0, 0
               inc eax ; terminating zero
               mov ln, eax
               mov hOutputput, alloc$(eax)
            invoke SendDlgItemMessage, hWnd,IDE_OUTPUT, WM_GETTEXT,ln,hOutputput
            invoke lstrlen,hInput

invoke lstrlen, addr szPassWord
invoke Rc4_setkey, addr szPassWord, eax

            invoke Rc4_crypt,hInput,eax
            invoke SetDlgItemText,hWnd,IDE_INPUT,hOutputput
        .endif         
          
	.elseif uMsg == WM_CLOSE 
	        EXIT:
		    invoke EndDialog,hWnd,0		             
  .endif
  xor eax, eax
  ret
DlgProc endp

Rc4_setkey proc Pass:DWORD, LenPass:DWORD
pushad

mov eax, 0FFFEFDFCh
mov ecx, 256/4
Init_rc4keytable:
mov dword ptr [rc4keytable+4*ecx-4], eax
sub eax, 04040404h
dec ecx
jnz Init_rc4keytable

xor eax, eax
mov edi, Pass

Key_return:
xor ebx, ebx
mov esi ,LenPass
jmp New_key

Key_loop:
inc bl
dec esi
jz Key_return

New_key:
mov dl, byte ptr [rc4keytable+ecx]
add al, byte ptr [edi+ebx]
add al, dl
mov dh, byte ptr [rc4keytable+eax]
mov byte ptr [rc4keytable+ecx], dh
mov byte ptr [rc4keytable+eax], dl
inc cl
jnz Key_loop

popad
ret
Rc4_setkey endp

Rc4_crypt proc iData:DWORD, LenData:DWORD
pushad
mov edi, LenData
mov esi, iData
test edi, edi
jz Rc4_enc_exit

xor eax, eax
xor edx, edx
xor ecx, ecx
        xor ebx, ebx

Rc4_enc_loop:
inc bl
mov dl, byte ptr [rc4keytable+ebx]
add al, dl
mov cl, byte ptr [rc4keytable+eax]
mov byte ptr [rc4keytable+ebx], cl
mov byte ptr [rc4keytable+eax], dl
add cl, dl
mov cl, byte ptr [rc4keytable+ecx]
xor byte ptr [esi], cl
inc esi
dec edi
jnz Rc4_enc_loop

xor eax, eax
mov edi, offset rc4keytable
mov ecx, 256/4
cld
rep stosd

Rc4_enc_exit:
popad
ret
Rc4_crypt endp

end start
